.\"	$NetBSD: dge.4,v 1.7 2004/10/04 19:06:46 rumble Exp $
.\"
.\" Copyright (c) 2004, SUNET, Swedish University Computer Network.
.\" All rights reserved.
.\"
.\" Written by Anders Magnusson for SUNET, Swedish University Computer Network.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"      This product includes software developed for the NetBSD Project by
.\"      SUNET, Swedish University Computer Network.
.\" 4. The name of SUNET may not be used to endorse or promote products
.\"    derived from this software without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY SUNET ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL WASABI SYSTEMS, INC
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd March 18, 2004
.Dt DGE 4
.Os
.Sh NAME
.Nm dge
.Nd Intel i82597EX Ten Gigabit Ethernet driver
.Sh SYNOPSIS
.Cd "dge* at pci? dev ? function ?"
.Sh DESCRIPTION
The
.Nm
device driver supports the Intel i82597EX PRO/10GbE LR Ethernet
adapter,
which uses a single mode fiber (1310nm) interface.
.Pp
The i82597EX supports IPv4/TCP/UDP checksumming in hardware, as well
as TCP Segmentation Offloading (TSO).
The driver does currently only support the hardware checksumming
features.
See
.Xr ifconfig 8
for information on how to enable the hardware checksum calculations.
.Pp
The driver also makes use of the
.Xr ifconfig 8
link flags
.Ar link0
and
.Ar link1
to set the PCIX burst size.
The burst size is set according to
this table:
.Pp
.Bl -column "link0" "link1" "burst size"
.It Em "link0	link1	burst size"
.It Li off Ta off Ta 512
.It Li on Ta off Ta 1024
.It Li off Ta on Ta 2048
.It Li on Ta on Ta 4096
.El
.Pp
A larger burst size will increase the transmit capacity of the card
dramatically but may have negative effect on other devices in
the system.
.Sh DIAGNOSTICS
.Bl -diag
.It dge%d: Tx packet consumes too many DMA segments, dropping...
The packet consisted of too many small mbufs and could therefore
not be loaded into a DMA map.
This is most unlikely, the driver can currently handle up to 100
segments, but over 80 segments has been seen using large (16k)
jumbo frames.
.Pp
.It dge%s: device timeout (txfree %d txsfree %d txnext %d)
The i82597EX had been given packets to send, but didn't interrupt
within 5 seconds.
This diagnostic is most likely the result of a hardware failure,
and the chip will be reset to resume normal operation.
.Pp
.It dge%d: Receive overrun
If the computer is under heavy load, the software may not be able to
keep up removing received datagrams from the receive queue, and
will therefore loose datagrams.
To avoid this, check that the other end is using the XON/XOFF
protocol, if possible, or increase the receive descriptor ring size
in the driver.
.Pp
.It dge%d: symbol error
.It dge%d: parity error
An error in the XGMII communication was detected.
This is a hardware error in the MAC\*[Lt]-\*[Gt]PHY communication bus.
.Pp
.It dge%d: CRC error
A CRC error in the received datagram was detected.
The error is probably caused in the fiber communication.
.Pp
.It dge%d: WARNING: reset failed to complete
This is a fatal error and means that the hardware is broken and
will most likely not function correctly.
.Pp
.It "dge%d: unable to allocate or map rx buffer %d error = %d"
The driver was not able to map a mbuf cluster page to a receive
descriptor entry in the receive ring.
Most likely the system has run out of mbuf clusters or have a too
small cluster map.
See the errno for more information.
.El
.Sh SEE ALSO
.Xr arp 4 ,
.Xr ifmedia 4 ,
.Xr netintro 4 ,
.Xr pci 4 ,
.Xr ifconfig 8
.Sh HISTORY
The
.Nm
driver first appeared in
.Nx 2.0 .
.Sh AUTHORS
The
.Nm
driver was written by
.An Anders Magnusson Aq ragge@ludd.luth.se .
.Sh BUGS
There should be an XGMII framework for the driver to use.
